/* HACK Below we use .hover instead of :hover because space.bringToFront()
   causes Firefox to forget :hover state */

.category-node .node-shape {
  position: absolute;
  z-index: 1000;
  /* Make to look like circle */
  border-radius: 50%;
  /* Avoid offset from border width */
  box-sizing: border-box;
  /* Fill space item */
  width: 100%;
  height: 100%;
  /* Default color */
  background: linear-gradient(#999999, #666666);
  /* Disable native touch actions for the node */
  touch-action: none;
  user-select: none;
  /* Node should act like clickable */
  cursor: pointer;
}

/* Label */
.category-node .node-label {
  position: absolute;
  top: 60px;
  left: 72px;
  z-index: 3000;
  display: none;
  font-size: 60px;
  font-family: Arial, Helvetica, sans-serif;
  color: var(--node-text-color);
  /* For moving label nicely when opened */
  transition: left 0.4s ease,
    top 0.4s ease,
    width 0.4s ease,
    font-size 0.4s ease,
    padding 0.4s ease;
  /* Label should act like clickable */
  cursor: pointer;
  pointer-events: none;
}
.category-node .node-label .node-label-prefix {
  font-size: 0.38em;
  margin-top: -1em;
  color: var(--node-text-color-secondary);
}
.category-node .node-label .node-label-name {
  line-height: 1em;
}
.category-node .node-label .node-label-postfix {
  font-size: 0.38em;
  color: var(--node-text-color-secondary);
}
.category-node .node-label .node-label-count {
  font-size: 0.38em;
  color: var(--node-text-color-secondary);
}
.category-node.grouping-node .node-label {
  position: relative;
  top: 0px;
  left: 0px;
  padding-top: 4.4rem;
  text-align: center;
}
.category-node.grouping-node .node-label .node-label-name {
  font-style: italic;
  color: var(--node-text-color-secondary);
}

.category-node.readable .node-label {
  display: block;
}

.category-node.selectable-node .node-shape,
.category-node.selectable-node .node-label {
  cursor: pointer;
}
.category-node.selectable-node.hover .node-label {
  background: rgba(0, 0, 20, 0.8);
  border-radius: 10px;
  top: 30px;
  left: 270px;
  padding: 0.21em 0.38em;
  display: block;
}

/* Node opening */
.category-node.openable-node.hover .node-shape {
  background: #999999; /* default */
  border: 3px solid var(--node-border-color-active);
}
.category-node.opened-node .node-shape {
  border: 3px solid var(--node-border-color-idle);
  background: var(--main-bg-color) !important; /* match with sky bg to visually hide edges below */
  box-shadow: inset 0 0 20px rgba(0, 0, 0, 0.3);
}
.category-node.opened-node.hover .node-shape {
  /* Revert hover border to default color to cancel above color styles.
     Any effect is annoying because the hover is losed soon.
     When the cursor enters the substratum, the stratum elements
     are not anymore true child of the node in DOM.
     The flickering effect is annoying. */
  background: var(--main-bg-color) !important;
  border: 3px solid var(--node-border-color-idle);
}
.category-node.opened-node .node-label,
.category-node.opened-node.hover .node-label {
  background: transparent;
  border-radius: 0;
  top: 60px;
  left: 270px;
  padding: 0;
}

.category-node.opened-node.loading .node-shape {
  border: 3px dashed var(--node-border-color-idle);
}

.category-node.repeated-node .node-shape {
  background: gray;
}

.category-node.warp-node .node-shape {
  background: black;
}

/* Node Hint Label */
.category-node .node-hint {
  display: none;
  pointer-events: none; /* hint pointer events cause flicker in hover logic */
}
.category-node.selectable-node.hover .node-hint {
  display: block;
  position: absolute;
  width: 256px;
  top: 0px;
  left: 0px;
  z-index: 2000;
  padding-top: 96px;
  text-align: center;

  font-size: 36px;
  font-family: Arial, Helvetica, sans-serif;
  font-style: italic;
  color: var(--node-text-color);
  opacity: 0.5;
}
.category-node.opened-node .node-hint,
.category-node.opened-node.hover .node-hint {
  display: none;
}
